#!/usr/local/bin/python

import numpy as np
import matplotlib.pyplot as plt

#########################################################
################# Read in Output Files ##################
#########################################################

# An = 5%
da_e_neg6_an5 = np.loadtxt('BFS2_1320_Da-6_Pe-2_An5.csv',delimiter=',',unpack=False)
da_e_neg7_an5 = np.loadtxt('BFS2_1320_Da-7_Pe-2_An5.csv',delimiter=',',unpack=False)
da_e_neg8_an5 = np.loadtxt('BFS2_1320_Da-8_Pe-2_An5.csv',delimiter=',',unpack=False)
da_e_neg9_an5 = np.loadtxt('BFS2_1320_Da-9_Pe-2_An5.csv',delimiter=',',unpack=False)
da_e_neg10_an5 = np.loadtxt('BFS2_1320_Da-10_Pe-2_An5.csv',delimiter=',',unpack=False)

# An = 10%
da_e_neg6_an10 = np.loadtxt('BFS2_1320_Da-6_Pe-2_An10.csv',delimiter=',',unpack=False)
da_e_neg7_an10 = np.loadtxt('BFS2_1320_Da-7_Pe-2_An10.csv',delimiter=',',unpack=False)
da_e_neg8_an10 = np.loadtxt('BFS2_1320_Da-8_Pe-2_An10.csv',delimiter=',',unpack=False)
da_e_neg9_an10 = np.loadtxt('BFS2_1320_Da-9_Pe-2_An10.csv',delimiter=',',unpack=False)
da_e_neg10_an10 = np.loadtxt('BFS2_1320_Da-10_Pe-2_An10.csv',delimiter=',',unpack=False)

# An = 15%
da_e_neg6_an15 = np.loadtxt('BFS2_1320_Da-6_Pe-2_An15.csv',delimiter=',',unpack=False)
da_e_neg7_an15 = np.loadtxt('BFS2_1320_Da-7_Pe-2_An15.csv',delimiter=',',unpack=False)
da_e_neg8_an15 = np.loadtxt('BFS2_1320_Da-8_Pe-2_An15.csv',delimiter=',',unpack=False)
da_e_neg9_an15 = np.loadtxt('BFS2_1320_Da-9_Pe-2_An15.csv',delimiter=',',unpack=False)
da_e_neg10_an15 = np.loadtxt('BFS2_1320_Da-10_Pe-2_An15.csv',delimiter=',',unpack=False)

# An = 20%
da_e_neg6_an20 = np.loadtxt('BFS2_1320_Da-6_Pe-2_An20.csv',delimiter=',',unpack=False)
da_e_neg7_an20 = np.loadtxt('BFS2_1320_Da-7_Pe-2_An20.csv',delimiter=',',unpack=False)
da_e_neg8_an20 = np.loadtxt('BFS2_1320_Da-8_Pe-2_An20.csv',delimiter=',',unpack=False)
da_e_neg9_an20 = np.loadtxt('BFS2_1320_Da-9_Pe-2_An20.csv',delimiter=',',unpack=False)
da_e_neg10_an20 = np.loadtxt('BFS2_1320_Da-10_Pe-2_An20.csv',delimiter=',',unpack=False)

# An = 25%
da_e_neg6_an25 = np.loadtxt('BFS2_1320_Da-6_Pe-2_An25.csv',delimiter=',',unpack=False)
da_e_neg7_an25 = np.loadtxt('BFS2_1320_Da-7_Pe-2_An25.csv',delimiter=',',unpack=False)
da_e_neg8_an25 = np.loadtxt('BFS2_1320_Da-8_Pe-2_An25.csv',delimiter=',',unpack=False)
da_e_neg9_an25 = np.loadtxt('BFS2_1320_Da-9_Pe-2_An25.csv',delimiter=',',unpack=False)
da_e_neg10_an25 = np.loadtxt('BFS2_1320_Da-10_Pe-2_An25.csv',delimiter=',',unpack=False)



#########################################################
############# Group Nondimensional Results ##############
#########################################################

# Time - all results are identical so 1 array given
ND_time = da_e_neg10_an10[0]

# Volume - all results are identical so 1 value given
ND_volume = da_e_neg10_an10[1][0]

# H2CO3 influx - all results are identical so 1 array given
ND_influx = da_e_neg10_an10[2]

#########################################################

# H2CO3 outflux at each time step
# An = 5%
ND_outflux_da_e_neg6_an5 = da_e_neg6_an5[3]
ND_outflux_da_e_neg7_an5 = da_e_neg7_an5[3]
ND_outflux_da_e_neg8_an5 = da_e_neg8_an5[3]
ND_outflux_da_e_neg9_an5 = da_e_neg9_an5[3]
ND_outflux_da_e_neg10_an5 = da_e_neg10_an5[3]

# An = 10%
ND_outflux_da_e_neg6_an10 = da_e_neg6_an10[3]
ND_outflux_da_e_neg7_an10 = da_e_neg7_an10[3]
ND_outflux_da_e_neg8_an10 = da_e_neg8_an10[3]
ND_outflux_da_e_neg9_an10 = da_e_neg9_an10[3]
ND_outflux_da_e_neg10_an10 = da_e_neg10_an10[3]

# An = 15%
ND_outflux_da_e_neg6_an15 = da_e_neg6_an15[3]
ND_outflux_da_e_neg7_an15 = da_e_neg7_an15[3]
ND_outflux_da_e_neg8_an15 = da_e_neg8_an15[3]
ND_outflux_da_e_neg9_an15 = da_e_neg9_an15[3]
ND_outflux_da_e_neg10_an15 = da_e_neg10_an15[3]

# An = 20%
ND_outflux_da_e_neg6_an20 = da_e_neg6_an20[3]
ND_outflux_da_e_neg7_an20 = da_e_neg7_an20[3]
ND_outflux_da_e_neg8_an20 = da_e_neg8_an20[3]
ND_outflux_da_e_neg9_an20 = da_e_neg9_an20[3]
ND_outflux_da_e_neg10_an20 = da_e_neg10_an20[3]

# An = 25%
ND_outflux_da_e_neg6_an25 = da_e_neg6_an25[3]
ND_outflux_da_e_neg7_an25 = da_e_neg7_an25[3]
ND_outflux_da_e_neg8_an25 = da_e_neg8_an25[3]
ND_outflux_da_e_neg9_an25 = da_e_neg9_an25[3]
ND_outflux_da_e_neg10_an25 = da_e_neg10_an25[3]

#########################################################

# CaCO3 mass precipitated during each dt
# An = 5%
ND_ppt_mass_da_e_neg6_an5 = da_e_neg6_an5[4]
ND_ppt_mass_da_e_neg7_an5 = da_e_neg7_an5[4]
ND_ppt_mass_da_e_neg8_an5 = da_e_neg8_an5[4]
ND_ppt_mass_da_e_neg9_an5 = da_e_neg9_an5[4]
ND_ppt_mass_da_e_neg10_an5 = da_e_neg10_an5[4]

# An = 10%
ND_ppt_mass_da_e_neg6_an10 = da_e_neg6_an10[4]
ND_ppt_mass_da_e_neg7_an10 = da_e_neg7_an10[4]
ND_ppt_mass_da_e_neg8_an10 = da_e_neg8_an10[4]
ND_ppt_mass_da_e_neg9_an10 = da_e_neg9_an10[4]
ND_ppt_mass_da_e_neg10_an10 = da_e_neg10_an10[4]

# An = 15%
ND_ppt_mass_da_e_neg6_an15 = da_e_neg6_an15[4]
ND_ppt_mass_da_e_neg7_an15 = da_e_neg7_an15[4]
ND_ppt_mass_da_e_neg8_an15 = da_e_neg8_an15[4]
ND_ppt_mass_da_e_neg9_an15 = da_e_neg9_an15[4]
ND_ppt_mass_da_e_neg10_an15 = da_e_neg10_an15[4]

# An = 20%
ND_ppt_mass_da_e_neg6_an20 = da_e_neg6_an20[4]
ND_ppt_mass_da_e_neg7_an20 = da_e_neg7_an20[4]
ND_ppt_mass_da_e_neg8_an20 = da_e_neg8_an20[4]
ND_ppt_mass_da_e_neg9_an20 = da_e_neg9_an20[4]
ND_ppt_mass_da_e_neg10_an20 = da_e_neg10_an20[4]

# An = 25%
ND_ppt_mass_da_e_neg6_an25 = da_e_neg6_an25[4]
ND_ppt_mass_da_e_neg7_an25 = da_e_neg7_an25[4]
ND_ppt_mass_da_e_neg8_an25 = da_e_neg8_an25[4]
ND_ppt_mass_da_e_neg9_an25 = da_e_neg9_an25[4]
ND_ppt_mass_da_e_neg10_an25 = da_e_neg10_an25[4]


#########################################################

# CaCO3 total cumulative mass precipitated at the end of t0
# An = 5%
ND_total_ppt_mass_da_e_neg6_an5 = da_e_neg6_an5[4][99]
ND_total_ppt_mass_da_e_neg7_an5 = da_e_neg7_an5[4][99]
ND_total_ppt_mass_da_e_neg8_an5 = da_e_neg8_an5[4][99]
ND_total_ppt_mass_da_e_neg9_an5 = da_e_neg9_an5[4][99]
ND_total_ppt_mass_da_e_neg10_an5 = da_e_neg10_an5[4][99]

# An = 10%
ND_total_ppt_mass_da_e_neg6_an10 = da_e_neg6_an10[4][99]
ND_total_ppt_mass_da_e_neg7_an10 = da_e_neg7_an10[4][99]
ND_total_ppt_mass_da_e_neg8_an10 = da_e_neg8_an10[4][99]
ND_total_ppt_mass_da_e_neg9_an10 = da_e_neg9_an10[4][99]
ND_total_ppt_mass_da_e_neg10_an10 = da_e_neg10_an10[4][99]

# An = 15%
ND_total_ppt_mass_da_e_neg6_an15 = da_e_neg6_an15[4][99]
ND_total_ppt_mass_da_e_neg7_an15 = da_e_neg7_an15[4][99]
ND_total_ppt_mass_da_e_neg8_an15 = da_e_neg8_an15[4][99]
ND_total_ppt_mass_da_e_neg9_an15 = da_e_neg9_an15[4][99]
ND_total_ppt_mass_da_e_neg10_an15 = da_e_neg10_an15[4][99]

# An = 20%
ND_total_ppt_mass_da_e_neg6_an20 = da_e_neg6_an20[4][99]
ND_total_ppt_mass_da_e_neg7_an20 = da_e_neg7_an20[4][99]
ND_total_ppt_mass_da_e_neg8_an20 = da_e_neg8_an20[4][99]
ND_total_ppt_mass_da_e_neg9_an20 = da_e_neg9_an20[4][99]
ND_total_ppt_mass_da_e_neg10_an20 = da_e_neg10_an20[4][99]

# An = 25%
ND_total_ppt_mass_da_e_neg6_an25 = da_e_neg6_an25[4][99]
ND_total_ppt_mass_da_e_neg7_an25 = da_e_neg7_an25[4][99]
ND_total_ppt_mass_da_e_neg8_an25 = da_e_neg8_an25[4][99]
ND_total_ppt_mass_da_e_neg9_an25 = da_e_neg9_an25[4][99]
ND_total_ppt_mass_da_e_neg10_an25 = da_e_neg10_an25[4][99]



#########################################################

# Precipitation rate
# An = 5%
ND_ppt_rate_da_e_neg6_an5 = da_e_neg6_an5[5]
ND_ppt_rate_da_e_neg7_an5 = da_e_neg7_an5[5]
ND_ppt_rate_da_e_neg8_an5 = da_e_neg8_an5[5]
ND_ppt_rate_da_e_neg9_an5 = da_e_neg9_an5[5]
ND_ppt_rate_da_e_neg10_an5 = da_e_neg10_an5[5]

# An = 10%
ND_ppt_rate_da_e_neg6_an10 = da_e_neg6_an10[5]
ND_ppt_rate_da_e_neg7_an10 = da_e_neg7_an10[5]
ND_ppt_rate_da_e_neg8_an10 = da_e_neg8_an10[5]
ND_ppt_rate_da_e_neg9_an10 = da_e_neg9_an10[5]
ND_ppt_rate_da_e_neg10_an10 = da_e_neg10_an10[5]

# An = 15%
ND_ppt_rate_da_e_neg6_an15 = da_e_neg6_an15[5]
ND_ppt_rate_da_e_neg7_an15 = da_e_neg7_an15[5]
ND_ppt_rate_da_e_neg8_an15 = da_e_neg8_an15[5]
ND_ppt_rate_da_e_neg9_an15 = da_e_neg9_an15[5]
ND_ppt_rate_da_e_neg10_an15 = da_e_neg10_an15[5]

# An = 20%
ND_ppt_rate_da_e_neg6_an20 = da_e_neg6_an20[5]
ND_ppt_rate_da_e_neg7_an20 = da_e_neg7_an20[5]
ND_ppt_rate_da_e_neg8_an20 = da_e_neg8_an20[5]
ND_ppt_rate_da_e_neg9_an20 = da_e_neg9_an20[5]
ND_ppt_rate_da_e_neg10_an20 = da_e_neg10_an20[5]

# An = 25%
ND_ppt_rate_da_e_neg6_an25 = da_e_neg6_an25[5]
ND_ppt_rate_da_e_neg7_an25 = da_e_neg7_an25[5]
ND_ppt_rate_da_e_neg8_an25 = da_e_neg8_an25[5]
ND_ppt_rate_da_e_neg9_an25 = da_e_neg9_an25[5]
ND_ppt_rate_da_e_neg10_an25 = da_e_neg10_an25[5]

#########################################################

# CaCO3 spatial average mass
# An = 5%
ND_avg_mass_da_e_neg6_an5 = da_e_neg6_an5[6]
ND_avg_mass_da_e_neg7_an5 = da_e_neg7_an5[6]
ND_avg_mass_da_e_neg8_an5 = da_e_neg8_an5[6]
ND_avg_mass_da_e_neg9_an5 = da_e_neg9_an5[6]
ND_avg_mass_da_e_neg10_an5 = da_e_neg10_an5[6]

# An = 10%
ND_avg_mass_da_e_neg6_an10 = da_e_neg6_an10[6]
ND_avg_mass_da_e_neg7_an10 = da_e_neg7_an10[6]
ND_avg_mass_da_e_neg8_an10 = da_e_neg8_an10[6]
ND_avg_mass_da_e_neg9_an10 = da_e_neg9_an10[6]
ND_avg_mass_da_e_neg10_an10 = da_e_neg10_an10[6]

# An = 15%
ND_avg_mass_da_e_neg6_an15 = da_e_neg6_an15[6]
ND_avg_mass_da_e_neg7_an15 = da_e_neg7_an15[6]
ND_avg_mass_da_e_neg8_an15 = da_e_neg8_an15[6]
ND_avg_mass_da_e_neg9_an15 = da_e_neg9_an15[6]
ND_avg_mass_da_e_neg10_an15 = da_e_neg10_an15[6]

# An = 20%
ND_avg_mass_da_e_neg6_an20 = da_e_neg6_an20[6]
ND_avg_mass_da_e_neg7_an20 = da_e_neg7_an20[6]
ND_avg_mass_da_e_neg8_an20 = da_e_neg8_an20[6]
ND_avg_mass_da_e_neg9_an20 = da_e_neg9_an20[6]
ND_avg_mass_da_e_neg10_an20 = da_e_neg10_an20[6]

# An = 25%
ND_avg_mass_da_e_neg6_an25 = da_e_neg6_an25[6]
ND_avg_mass_da_e_neg7_an25 = da_e_neg7_an25[6]
ND_avg_mass_da_e_neg8_an25 = da_e_neg8_an25[6]
ND_avg_mass_da_e_neg9_an25 = da_e_neg9_an25[6]
ND_avg_mass_da_e_neg10_an25 = da_e_neg10_an25[6]


#########################################################
################# Redimensionalisations #################
#########################################################

# Time (yr)

# Convert non dimensional time steps into seconds (/10000) and then to years (/3.154e7)
# All results are identical so 1 array given

D_time = (ND_time*13200)/3.154e7

# Volume (mm3)

# Convert non dimensional volume
# All results are identical so 1 value given

D_volume_mm3 = (ND_volume*(1320**3))/1e9
D_volume_m3 = D_volume_mm3/1e9


# Masses

# All concentrations are mass fractions: concentration of CaCO3 etc... as a fraction of the total pore space mass
#(ND)c0 = mass of H2CO3/mass of pore space
#(ND)c1 = mass of An/mass of pore space
#(ND)c2 = mass of CaCO3/mass of pore space
# Multiply the ND output by the dimensional mass of the pore space to get the mass of c0,1,2
# (rearrange the above equations by moving the mass of pore space term to the left)
# Therefore, we need to provide a mass of the pore space. We make the assumption that we fill it with water

# We calculate the mass of the pore space using: Mass = Density * Volume
water_rho = 997 #kg/m3

pore_space_mass = (water_rho * D_volume_m3)*1e9 #ug
print('The mass of the pore space is: ',pore_space_mass,' ug.')

# We can now multiply any nondimensional mass value by the pore space mass to obtain a dimensional mass

# CaCO3 total cumulative mass precipitated at the end of t0
# An = 5%
D_CaCO3_mass_da_e_neg6_an5 = ND_total_ppt_mass_da_e_neg6_an5*pore_space_mass
D_CaCO3_mass_da_e_neg7_an5 = ND_total_ppt_mass_da_e_neg7_an5*pore_space_mass
D_CaCO3_mass_da_e_neg8_an5 = ND_total_ppt_mass_da_e_neg8_an5*pore_space_mass
D_CaCO3_mass_da_e_neg9_an5 = ND_total_ppt_mass_da_e_neg9_an5*pore_space_mass
D_CaCO3_mass_da_e_neg10_an5 = ND_total_ppt_mass_da_e_neg10_an5*pore_space_mass

# An = 10%
D_CaCO3_mass_da_e_neg6_an10 = ND_total_ppt_mass_da_e_neg6_an10*pore_space_mass
D_CaCO3_mass_da_e_neg7_an10 = ND_total_ppt_mass_da_e_neg7_an10*pore_space_mass
D_CaCO3_mass_da_e_neg8_an10 = ND_total_ppt_mass_da_e_neg8_an10*pore_space_mass
D_CaCO3_mass_da_e_neg9_an10 = ND_total_ppt_mass_da_e_neg9_an10*pore_space_mass
D_CaCO3_mass_da_e_neg10_an10 = ND_total_ppt_mass_da_e_neg10_an10*pore_space_mass

# An = 15%
D_CaCO3_mass_da_e_neg6_an15 = ND_total_ppt_mass_da_e_neg6_an15*pore_space_mass
D_CaCO3_mass_da_e_neg7_an15 = ND_total_ppt_mass_da_e_neg7_an15*pore_space_mass
D_CaCO3_mass_da_e_neg8_an15 = ND_total_ppt_mass_da_e_neg8_an15*pore_space_mass
D_CaCO3_mass_da_e_neg9_an15 = ND_total_ppt_mass_da_e_neg9_an15*pore_space_mass
D_CaCO3_mass_da_e_neg10_an15 = ND_total_ppt_mass_da_e_neg10_an15*pore_space_mass

# An = 20%
D_CaCO3_mass_da_e_neg6_an20 = ND_total_ppt_mass_da_e_neg6_an20*pore_space_mass
D_CaCO3_mass_da_e_neg7_an20 = ND_total_ppt_mass_da_e_neg7_an20*pore_space_mass
D_CaCO3_mass_da_e_neg8_an20 = ND_total_ppt_mass_da_e_neg8_an20*pore_space_mass
D_CaCO3_mass_da_e_neg9_an20 = ND_total_ppt_mass_da_e_neg9_an20*pore_space_mass
D_CaCO3_mass_da_e_neg10_an20 = ND_total_ppt_mass_da_e_neg10_an20*pore_space_mass

# An = 25%
D_CaCO3_mass_da_e_neg6_an25 = ND_total_ppt_mass_da_e_neg6_an25*pore_space_mass
D_CaCO3_mass_da_e_neg7_an25 = ND_total_ppt_mass_da_e_neg7_an25*pore_space_mass
D_CaCO3_mass_da_e_neg8_an25 = ND_total_ppt_mass_da_e_neg8_an25*pore_space_mass
D_CaCO3_mass_da_e_neg9_an25 = ND_total_ppt_mass_da_e_neg9_an25*pore_space_mass
D_CaCO3_mass_da_e_neg10_an25 = ND_total_ppt_mass_da_e_neg10_an25*pore_space_mass



# CaCO3 spatial average mass
# An = 5%
D_avg_mass_da_e_neg6_an5 = ND_avg_mass_da_e_neg6_an5*pore_space_mass
D_avg_mass_da_e_neg7_an5 = ND_avg_mass_da_e_neg7_an5*pore_space_mass
D_avg_mass_da_e_neg8_an5 = ND_avg_mass_da_e_neg8_an5*pore_space_mass
D_avg_mass_da_e_neg9_an5 = ND_avg_mass_da_e_neg9_an5*pore_space_mass
D_avg_mass_da_e_neg10_an5 = ND_avg_mass_da_e_neg10_an5*pore_space_mass

# An = 10%
D_avg_mass_da_e_neg6_an10 = ND_avg_mass_da_e_neg6_an10*pore_space_mass
D_avg_mass_da_e_neg7_an10 = ND_avg_mass_da_e_neg7_an10*pore_space_mass
D_avg_mass_da_e_neg8_an10 = ND_avg_mass_da_e_neg8_an10*pore_space_mass
D_avg_mass_da_e_neg9_an10 = ND_avg_mass_da_e_neg9_an10*pore_space_mass
D_avg_mass_da_e_neg10_an10 = ND_avg_mass_da_e_neg10_an10*pore_space_mass

# An = 15%
D_avg_mass_da_e_neg6_an15 = ND_avg_mass_da_e_neg6_an15*pore_space_mass
D_avg_mass_da_e_neg7_an15 = ND_avg_mass_da_e_neg7_an15*pore_space_mass
D_avg_mass_da_e_neg8_an15 = ND_avg_mass_da_e_neg8_an15*pore_space_mass
D_avg_mass_da_e_neg9_an15 = ND_avg_mass_da_e_neg9_an15*pore_space_mass
D_avg_mass_da_e_neg10_an15 = ND_avg_mass_da_e_neg10_an15*pore_space_mass

# An = 20%
D_avg_mass_da_e_neg6_an20 = ND_avg_mass_da_e_neg6_an20*pore_space_mass
D_avg_mass_da_e_neg7_an20 = ND_avg_mass_da_e_neg7_an20*pore_space_mass
D_avg_mass_da_e_neg8_an20 = ND_avg_mass_da_e_neg8_an20*pore_space_mass
D_avg_mass_da_e_neg9_an20 = ND_avg_mass_da_e_neg9_an20*pore_space_mass
D_avg_mass_da_e_neg10_an20 = ND_avg_mass_da_e_neg10_an20*pore_space_mass

# An = 25%
D_avg_mass_da_e_neg6_an25 = ND_avg_mass_da_e_neg6_an25*pore_space_mass
D_avg_mass_da_e_neg7_an25 = ND_avg_mass_da_e_neg7_an25*pore_space_mass
D_avg_mass_da_e_neg8_an25 = ND_avg_mass_da_e_neg8_an25*pore_space_mass
D_avg_mass_da_e_neg9_an25 = ND_avg_mass_da_e_neg9_an25*pore_space_mass
D_avg_mass_da_e_neg10_an25 = ND_avg_mass_da_e_neg10_an25*pore_space_mass


# Precipitation rate
# We need to also divide by time here to get a mass precipitated per unit time
# An = 5%
D_ppt_rate_da_e_neg6_an5 = (ND_ppt_rate_da_e_neg6_an5*pore_space_mass)/D_time
D_ppt_rate_da_e_neg7_an5 = (ND_ppt_rate_da_e_neg7_an5*pore_space_mass)/D_time
D_ppt_rate_da_e_neg8_an5 = (ND_ppt_rate_da_e_neg8_an5*pore_space_mass)/D_time
D_ppt_rate_da_e_neg9_an5 = (ND_ppt_rate_da_e_neg9_an5*pore_space_mass)/D_time
D_ppt_rate_da_e_neg10_an5 = (ND_ppt_rate_da_e_neg10_an5*pore_space_mass)/D_time

# An = 10%
D_ppt_rate_da_e_neg6_an10 = (ND_ppt_rate_da_e_neg6_an10*pore_space_mass)/D_time
D_ppt_rate_da_e_neg7_an10 = (ND_ppt_rate_da_e_neg7_an10*pore_space_mass)/D_time
D_ppt_rate_da_e_neg8_an10 = (ND_ppt_rate_da_e_neg8_an10*pore_space_mass)/D_time
D_ppt_rate_da_e_neg9_an10 = (ND_ppt_rate_da_e_neg9_an10*pore_space_mass)/D_time
D_ppt_rate_da_e_neg10_an10 = (ND_ppt_rate_da_e_neg10_an10*pore_space_mass)/D_time

# An = 15%
D_ppt_rate_da_e_neg6_an15 = (ND_ppt_rate_da_e_neg6_an15*pore_space_mass)/D_time
D_ppt_rate_da_e_neg7_an15 = (ND_ppt_rate_da_e_neg7_an15*pore_space_mass)/D_time
D_ppt_rate_da_e_neg8_an15 = (ND_ppt_rate_da_e_neg8_an15*pore_space_mass)/D_time
D_ppt_rate_da_e_neg9_an15 = (ND_ppt_rate_da_e_neg9_an15*pore_space_mass)/D_time
D_ppt_rate_da_e_neg10_an15 = (ND_ppt_rate_da_e_neg10_an15*pore_space_mass)/D_time

# An = 20%
D_ppt_rate_da_e_neg6_an20 = (ND_ppt_rate_da_e_neg6_an20*pore_space_mass)/D_time
D_ppt_rate_da_e_neg7_an20 = (ND_ppt_rate_da_e_neg7_an20*pore_space_mass)/D_time
D_ppt_rate_da_e_neg8_an20 = (ND_ppt_rate_da_e_neg8_an20*pore_space_mass)/D_time
D_ppt_rate_da_e_neg9_an20 = (ND_ppt_rate_da_e_neg9_an20*pore_space_mass)/D_time
D_ppt_rate_da_e_neg10_an20 = (ND_ppt_rate_da_e_neg10_an20*pore_space_mass)/D_time

# An = 25%
D_ppt_rate_da_e_neg6_an25 = (ND_ppt_rate_da_e_neg6_an25*pore_space_mass)/D_time
D_ppt_rate_da_e_neg7_an25 = (ND_ppt_rate_da_e_neg7_an25*pore_space_mass)/D_time
D_ppt_rate_da_e_neg8_an25 = (ND_ppt_rate_da_e_neg8_an25*pore_space_mass)/D_time
D_ppt_rate_da_e_neg9_an25 = (ND_ppt_rate_da_e_neg9_an25*pore_space_mass)/D_time
D_ppt_rate_da_e_neg10_an25 = (ND_ppt_rate_da_e_neg10_an25*pore_space_mass)/D_time


print('The range of total CaCO3 precipitated after 2,000 years for An = 5% is:', D_CaCO3_mass_da_e_neg6_an5-D_CaCO3_mass_da_e_neg10_an5, 'ug')
print('The range of total CaCO3 precipitated after 2,000 years for An = 25% is:', D_CaCO3_mass_da_e_neg6_an25-D_CaCO3_mass_da_e_neg10_an25, 'ug')

print('The range of total CaCO3 precipitated after 2,000 years for Da = -6 is:', D_CaCO3_mass_da_e_neg6_an25-D_CaCO3_mass_da_e_neg6_an5, 'ug')
print('The range of total CaCO3 precipitated after 2,000 years for Da = -10 is:', D_CaCO3_mass_da_e_neg10_an25-D_CaCO3_mass_da_e_neg10_an5, 'ug')

print('The change in precipitation rate between 1 and 100 years for Da = -6 is:', D_ppt_rate_da_e_neg6_an10[0]-D_ppt_rate_da_e_neg6_an10[5], 'ug/year')
print('The change in precipitation rate between 1 and 100 years for Da = -10 is:', D_ppt_rate_da_e_neg10_an10[0]-D_ppt_rate_da_e_neg10_an10[5], 'ug/year')

print('The change in precipitation rate between 100 and 1000 years for Da = -6 is:', D_ppt_rate_da_e_neg6_an10[5]-D_ppt_rate_da_e_neg6_an10[45], 'ug/year')
print('The change in precipitation rate between 100 and 1000 years for Da = -10 is:', D_ppt_rate_da_e_neg10_an10[5]-D_ppt_rate_da_e_neg10_an10[45], 'ug/year')

# print('The total CaCO3 precipitated after 2,000 years for Da = -6 and 25% An is:', D_CaCO3_mass_da_e_neg6_an25, 'ug')
# print('The spatial average CaCO3 precipitated after 2,000 years for Da = -6 and 25% An is:', D_avg_mass_da_e_neg6_an25, 'ug')
# print('The total CaCO3 precipitated after 2,000 years for Da = -10 and 5% An is:', D_CaCO3_mass_da_e_neg10_an5, 'ug')
# print('The total CaCO3 precipitated after 2,000 years for Da = -8 and 10% An is:', D_CaCO3_mass_da_e_neg8_an10, 'ug')


#########################################################
################### Plotting Figures ####################
#########################################################

# Precipitated mass over time 
plt.figure()

plt.plot(D_time,D_avg_mass_da_e_neg8_an5,'-')
plt.plot(D_time,D_avg_mass_da_e_neg8_an10,'-')
plt.plot(D_time,D_avg_mass_da_e_neg8_an15,'-')
plt.plot(D_time,D_avg_mass_da_e_neg8_an20,'-')
plt.plot(D_time,D_avg_mass_da_e_neg8_an25,'-')


plt.xlabel('Time (years)')
plt.ylabel(r'Spatial Average Precipitated CaCO$_{3}$ (μg)')
plt.legend(['An = 5%','An = 10%','An = 15%','An = 20%','An = 25%'])

plt.text(40,0.0065,r'$\mathcal{D}a = 1\times10^{-8}$',fontsize=13)
plt.text(40,0.006,r'$\mathcal{P}e = 4.3\times10^{-2}$',fontsize=13)

plt.xlim(0,2000)
plt.ylim(0,0.008)


#plt.savefig('average_ppt.png',dpi=100,format='png')


# Precipitation rate
plt.figure()

plt.plot(D_time,D_ppt_rate_da_e_neg6_an10,'-')
plt.plot(D_time,D_ppt_rate_da_e_neg7_an10,'-')
plt.plot(D_time,D_ppt_rate_da_e_neg8_an10,'-')
plt.plot(D_time,D_ppt_rate_da_e_neg9_an10,'-')
plt.plot(D_time,D_ppt_rate_da_e_neg10_an10,'-')

plt.yscale('log')
plt.ylim(1e-17,1e-7)
plt.xlim(0,2000)
plt.xlabel('Time (years)')
plt.ylabel(r'CaCO$_{3}$ Precipitation Rate (μg/yr)')
plt.legend([r'$\mathcal{D}a = 1\times10^{-6}$',r'$\mathcal{D}a = 1\times10^{-7}$',r'$\mathcal{D}a = 1\times10^{-8}$',r'$\mathcal{D}a = 1\times10^{-9}$',r'$\mathcal{D}a = 1\times10^{-10}$'],ncol=2,loc=1)

plt.text(20,2e-8,r'$\mathcal{P}e = 4.3\times10^{-2}$',fontsize=13)
plt.text(20,2e-9,'An = 10%', fontsize=13)


#plt.savefig('ppt_rate_variable_Da.png',dpi=100,format='png')


# Total precipitation after 2,000 years
plt.figure()

x = [0.05,0.1,0.15,0.2,0.25]
y_da6 = [D_CaCO3_mass_da_e_neg6_an5,D_CaCO3_mass_da_e_neg6_an10,D_CaCO3_mass_da_e_neg6_an15,D_CaCO3_mass_da_e_neg6_an20,D_CaCO3_mass_da_e_neg6_an25]
y_da7 = [D_CaCO3_mass_da_e_neg7_an5,D_CaCO3_mass_da_e_neg7_an10,D_CaCO3_mass_da_e_neg7_an15,D_CaCO3_mass_da_e_neg7_an20,D_CaCO3_mass_da_e_neg7_an25]
y_da8 = [D_CaCO3_mass_da_e_neg8_an5,D_CaCO3_mass_da_e_neg8_an10,D_CaCO3_mass_da_e_neg8_an15,D_CaCO3_mass_da_e_neg8_an20,D_CaCO3_mass_da_e_neg8_an25]
y_da9 = [D_CaCO3_mass_da_e_neg9_an5,D_CaCO3_mass_da_e_neg9_an10,D_CaCO3_mass_da_e_neg9_an15,D_CaCO3_mass_da_e_neg9_an20,D_CaCO3_mass_da_e_neg9_an25]
y_da10 = [D_CaCO3_mass_da_e_neg10_an5,D_CaCO3_mass_da_e_neg10_an10,D_CaCO3_mass_da_e_neg10_an15,D_CaCO3_mass_da_e_neg10_an20,D_CaCO3_mass_da_e_neg10_an25]

plt.plot(x,y_da6,'--o')
plt.plot(x,y_da7,'--o')
plt.plot(x,y_da8,'--o')
plt.plot(x,y_da9,'--o')
plt.plot(x,y_da10,'--o')

plt.yscale('log')
plt.ylim(2e-7,1)

plt.ylabel(r'Total CaCO$_{3}$ Precipitated after 2,000 years (μg)')
plt.xlabel('An%')

labels = ['5','10','15','20','25']
plt.xticks(x,labels)

plt.legend([r'$\mathcal{D}a = 1\times10^{-6}$',r'$\mathcal{D}a = 1\times10^{-7}$',r'$\mathcal{D}a = 1\times10^{-8}$',r'$\mathcal{D}a = 1\times10^{-9}$',r'$\mathcal{D}a = 1\times10^{-10}$'],ncol=2,loc=2)
plt.text(0.19,0.36,r'$\mathcal{P}e = 4.3\times10^{-2}$',fontsize=13)

#plt.savefig('total_ppt_variable_An.png',dpi=100,format='png')



# Precipitated mass over time with anorthite ranges
plt.figure()

D_time = np.delete(D_time,0)
D_avg_mass_da_e_neg8_an5 = np.delete(D_avg_mass_da_e_neg8_an5,0)
D_avg_mass_da_e_neg8_an25 = np.delete(D_avg_mass_da_e_neg8_an25,0)
D_avg_mass_da_e_neg9_an5 = np.delete(D_avg_mass_da_e_neg9_an5,0)
D_avg_mass_da_e_neg9_an25 = np.delete(D_avg_mass_da_e_neg9_an25,0)
D_avg_mass_da_e_neg10_an5 = np.delete(D_avg_mass_da_e_neg10_an5,0)
D_avg_mass_da_e_neg10_an25 = np.delete(D_avg_mass_da_e_neg10_an25,0)
D_avg_mass_da_e_neg7_an5 = np.delete(D_avg_mass_da_e_neg7_an5,0)
D_avg_mass_da_e_neg7_an25 = np.delete(D_avg_mass_da_e_neg7_an25,0)
D_avg_mass_da_e_neg6_an5 = np.delete(D_avg_mass_da_e_neg6_an5,0)
D_avg_mass_da_e_neg6_an25 = np.delete(D_avg_mass_da_e_neg6_an25,0)


plt.plot(D_time,D_avg_mass_da_e_neg6_an5,'--',color='k')
plt.plot(D_time,D_avg_mass_da_e_neg6_an25,'-',color='k')
plt.plot(D_time,D_avg_mass_da_e_neg7_an5,'--',color='k',label='_nolegend_')
plt.plot(D_time,D_avg_mass_da_e_neg7_an25,'-',color='k',label='_nolegend_')
plt.plot(D_time,D_avg_mass_da_e_neg8_an5,'--',color='k',label='_nolegend_')
plt.plot(D_time,D_avg_mass_da_e_neg8_an25,'-',color='k',label='_nolegend_')
plt.plot(D_time,D_avg_mass_da_e_neg9_an5,'--',color='k',label='_nolegend_')
plt.plot(D_time,D_avg_mass_da_e_neg9_an25,'-',color='k',label='_nolegend_')
plt.plot(D_time,D_avg_mass_da_e_neg10_an5,'--',color='k',label='_nolegend_')
plt.plot(D_time,D_avg_mass_da_e_neg10_an25,'-',color='k',label='_nolegend_')


plt.fill_between(D_time,D_avg_mass_da_e_neg10_an5,D_avg_mass_da_e_neg10_an25,color='magenta',alpha=0.5)
plt.fill_between(D_time,D_avg_mass_da_e_neg9_an5,D_avg_mass_da_e_neg9_an25,color='red',alpha=0.5)
plt.fill_between(D_time,D_avg_mass_da_e_neg8_an5,D_avg_mass_da_e_neg8_an25,color='green',alpha=0.5)
plt.fill_between(D_time,D_avg_mass_da_e_neg7_an5,D_avg_mass_da_e_neg7_an25,color='blue',alpha=0.5)
plt.fill_between(D_time,D_avg_mass_da_e_neg6_an5,D_avg_mass_da_e_neg6_an25,color='yellow',alpha=0.5)


plt.xlabel('Time (years)')
plt.ylabel(r'Spatial Average Precipitated CaCO$_{3}$ (μg)')
plt.legend(['An = 5%','An = 25%',r'$\mathcal{D}a = 1\times10^{-10}$',r'$\mathcal{D}a = 1\times10^{-9}$',r'$\mathcal{D}a = 1\times10^{-8}$',r'$\mathcal{D}a = 1\times10^{-7}$',r'$\mathcal{D}a = 1\times10^{-6}$'],loc=4,ncol=2)


plt.text(40,0.32,r'$\mathcal{P}e = 4.3\times10^{-2}$',fontsize=13)

plt.xlim(0,2000)
plt.ylim(1e-8,1)
plt.yscale('log')

#plt.savefig('average_ppt_an_ranges.png',dpi=100,format='png')





plt.show()